/*
	Class for youtube player  Basic code taken by Tour de Flex YouTube API Sample:
	http://www.adobe.com/devnet-archive/flex/tourdeflex/web/#docIndex=0;illustIndex=3;sampleId=19810
	
	LIBRARIES/CODE USED IN THIS CLASS
	http://code.google.com/p/as3-youtube-data-api/ by Martin Legris
	http://code.google.com/apis/youtube/flash_api_reference.html
*/

package lib
{
	import flash.display.BitmapData;
	import flash.display.Loader;
	import flash.display.LoaderInfo;
	import flash.events.IOErrorEvent;
	import flash.net.URLRequest;
	import flash.system.LoaderContext;
	import flash.utils.ByteArray;
	
	import mx.controls.SWFLoader;
	
	
	
	public class YouTubeInterface extends Object
	{

		
		protected var loader:Loader;
		protected var copyLoader:Loader;
		protected var swfLoader:SWFLoader;
		private var _width:int;
		private var _height:int;
		//private var _proxyUrl:String = "http://localhost/videoMixer_1/youTubeProxy.php?url=";
		
		
		[Bindable]
		protected var player:Object;
		
		public function YouTubeInterface(container:SWFLoader, width:int, height:int){
			swfLoader = container;
			_width = width;
			_height = height;
			loader = new Loader();
			copyLoader = new Loader();
			this.loadVideoPlayer();
		}
		
		protected function loadVideoPlayer():void {
			// Load the YouTube Video Player SWF here and then we'll embed it to show how that API is used. It can then be used to respond 
			// to different events. See this URL for more info: http://code.google.com/apis/youtube/flash_api_reference.html#Examples
			loader.contentLoaderInfo.addEventListener(Event.INIT, onLoaderInit);
			var loaderContex:LoaderContext = new LoaderContext();
			loaderContex.checkPolicyFile = true;
			loader.load(new URLRequest("http://www.youtube.com/apiplayer?version=3"), loaderContex);
			//loader.load(new URLRequest(_proxyUrl+"http://www.youtube.com/apiplayer?version=3"), loaderContex);
		}
		
		protected function onLoaderInit(event:Event):void {
		    loader.content.addEventListener("onReady", onPlayerReady);
		    loader.content.addEventListener("onError", onPlayerError);
		    loader.content.addEventListener("onStateChange", onPlayerStateChange);
		    loader.content.addEventListener("onPlaybackQualityChange", onVideoPlaybackQualityChange);
		}
		
		protected function onPlayerReady(event:Event):void {
			// Event.data contains the event parameter, which is the Player API ID 
			trace("player ready:", Object(event).data);
		    player = loader.content;
		    player.setSize(_width, _height);  						
		   	swfLoader.addEventListener(flash.events.IOErrorEvent.IO_ERROR , onSWFLoaderIoError);
			swfLoader.autoLoad = true;
			swfLoader.scaleContent = true;
			swfLoader.maintainAspectRatio = true;
			swfLoader.load(player);
		}
		
		protected function onPlayerError(event:Event):void {
		    trace("Player error:", Object(event).data);
		}
			
		protected function onPlayerStateChange(event:Event):void {
		    trace("Player state changed:", Object(event).data);
		}
			
		protected function onVideoPlaybackQualityChange(event:Event):void {
		    trace("Video quality playback change:", Object(event).data);
		}
		
		
		protected function onSWFLoaderIoError(event:IOErrorEvent):void {
			  trace('SWFLoader - IoError: ' + event.text);
		}
		
		//PUBLIC FUNCTIONS FOR THE PLAYER
		
		public function onVideoSelected(videoId:String):void {
			 player.cueVideoById(videoId);
		}
	
		public function loadVideo(videoId:String):void {
			player.loadVideoById(videoId);
		}
		
		public function playVideo():void {
			player.playVideo();
		}
		
		public function pauseVideo():void {
			player.pauseVideo();	
		}
		
		public function stopVideo():void {
			player.stopVideo();
		}
		
		public function seekTo(seconds:Number, allowSeekAhead:Boolean):void {
			player.seekTo(seconds, allowSeekAhead);
		}
		
		public function setVolume(volume:int):void {
			player.setVolume(volume);
		}
		
		
		public function mute():void {
			player.mute();
		}
		
		public function unMute():void {
			player.unMute();
		}
		
		public function setSize(width:Number, height:Number):void {
			_width = width;
			_height = height;
			player.setSize(width, height);
		}
		
		public function getVideoBytesLoaded():Number {
			var bytes:Number = player.getVideoBytesLoaded();
			return bytes;
		}
		
		public function getVideoBytesTotal():Number {
			var total:Number = player.getVideoBytesTotal();
			return total;			
		}
    
		public function getCurrentTime():Number {
			var seconds:Number= player.getCurrentTime();
			return seconds;
		}
		
		public function getDuration():Number {
			var duration:Number = player.getDuration();
			return duration;
		}
		
		public function getState():int {
			return player.getPlayerState();
		}		
		
	}
}